import { EditorView } from '@codemirror/view';
import { ConfigType } from './type';
import './style.css';
export default class MiniPlayground {
    static version: string;
    static encode: (value: string) => string;
    static decode: (value: string) => string;
    readonly version: string;
    el: HTMLDivElement;
    config: Required<ConfigType>;
    editor: EditorView;
    loading: boolean;
    isClick: boolean;
    iframe: HTMLIFrameElement;
    maskEl: HTMLDivElement;
    loadEl: HTMLDivElement;
    codeEl: HTMLDivElement;
    editorEl: HTMLDivElement;
    lineEl: HTMLDivElement;
    contentEl: HTMLDivElement;
    searchEl: HTMLInputElement;
    ldqStaticResources: string[];
    constructor(config?: ConfigType);
    init(): Promise<void>;
    reset(): void;
    private initDom;
    private initEvent;
    private initCodeMirror;
    setValue(value: string): void;
    getValue(): string;
    getString(): string;
    setCode(code: string): void;
    getCode(): string;
    setStyle(el: HTMLDivElement, styles: {
        [key: string]: string | number;
    }): void;
    private addClass;
    render(): void;
    private initStatisResources;
    private triggleLoading;
    private renderIframe;
}
